-- < event.ex > - demo for event.e
-- press ESC to exit

include graphics.e
include event.e

constant event_codes = {{RIGHT_SHIFT_UP,RIGHT_SHIFT_DOWN,LEFT_SHIFT_UP, 
    LEFT_SHIFT_DOWN,SHIFT_UP,SHIFT_DOWN,CTRL_UP,CTRL_DOWN,ALT_UP,ALT_DOWN,
    SCROLL_LOCK,SCROLL_UNLOCK,NUM_LOCK,NUM_UNLOCK,CAPS_LOCK,CAPS_UNLOCK,
    INSERT_ON,INSERT_OFF,LEFT_CTRL_UP,LEFT_CTRL_DOWN,LEFT_ALT_UP,
    LEFT_ALT_DOWN,RIGHT_CTRL_UP,RIGHT_CTRL_DOWN,RIGHT_ALT_UP,RIGHT_ALT_DOWN, 
    SCROLL_LOCK_UP,SCROLL_LOCK_DOWN,NUM_LOCK_UP,NUM_LOCK_DOWN,CAPS_LOCK_UP,
    CAPS_LOCK_DOWN,MOUSE_MOVE,MOUSE_LEFT_DOWN,MOUSE_LEFT_UP,MOUSE_RIGHT_DOWN,
    MOUSE_RIGHT_UP,MOUSE_MID_DOWN,MOUSE_MID_UP,MOUSE_LEFT_HELD,
    MOUSE_LEFT_DOUBLE,MOUSE_LEFT_DRAG,MOUSE_RIGHT_HELD,MOUSE_RIGHT_DOUBLE,
    MOUSE_RIGHT_DRAG,MOUSE_MID_HELD,MOUSE_MID_DOUBLE,MOUSE_MID_DRAG},
    {"RIGHT_SHIFT_UP","RIGHT_SHIFT_DOWN","LEFT_SHIFT_UP","LEFT_SHIFT_DOWN",
    "SHIFT_UP","SHIFT_DOWN","CTRL_UP","CTRL_DOWN","ALT_UP","ALT_DOWN",
    "SCROLL_LOCK","SCROLL_UNLOCK","NUM_LOCK","NUM_UNLOCK","CAPS_LOCK",
    "CAPS_UNLOCK","INSERT_ON","INSERT_OFF","LEFT_CTRL_UP","LEFT_CTRL_DOWN",
    "LEFT_ALT_UP","LEFT_ALT_DOWN","RIGHT_CTRL_UP","RIGHT_CTRL_DOWN",
    "RIGHT_ALT_UP","RIGHT_ALT_DOWN","SCROLL_LOCK_UP","SCROLL_LOCK_DOWN",
    "NUM_LOCK_UP","NUM_LOCK_DOWN","CAPS_LOCK_UP","CAPS_LOCK_DOWN",
    "MOUSE_MOVE","MOUSE_LEFT_DOWN","MOUSE_LEFT_UP","MOUSE_RIGHT_DOWN",
    "MOUSE_RIGHT_UP","MOUSE_MID_DOWN","MOUSE_MID_UP","MOUSE_LEFT_HELD",
    "MOUSE_LEFT_DOUBLE","MOUSE_LEFT_DRAG","MOUSE_RIGHT_HELD",
    "MOUSE_RIGHT_DOUBLE","MOUSE_RIGHT_DRAG","MOUSE_MID_HELD",
    "MOUSE_MID_DOUBLE","MOUSE_MID_DRAG"}}
constant alt_lets = {286,304,302,288,274,289,290,291,279,292,293,
    294,306,305,280,281,272,275,287,276,278,303,273,301,277,300},
    alt_nums = {385,376,377,378,379,380,381,382,383,384}
constant key_codes = {{8,9,13,27,32,271,327,328,329,331,333,335,336,
    337,338,339,315,316,317,318,319,320,321,322,323,324,389,390},
    {"BACKSPACE","TAB","ENTER","ESC","SPACE","SHIFT_TAB","HOME","UP",
    "PAGE_UP","LEFT","RIGHT","END","DOWN","PAGE_DOWN","INSERT","DELETE",
    "F1","F2","F3","F4","F5","F6","F7","F8","F9","F10","F11","F12"}}
    
integer line

procedure nag()
    if line >= 24 then
	clear_screen()
	line = 0
    end if
    mouse_pointer(0)
    puts(1, "ESC exits...\n")
    mouse_pointer(1)
    line += 1
end procedure

procedure nag2()
    if line >= 24 then
	clear_screen()
	line = 0
    end if
    mouse_pointer(0)
    puts(1, "So push a key already!\n")
    mouse_pointer(1)
    line += 1
end procedure

procedure main()
    integer event, void
    void = set_timer(10, 1, routine_id("nag"))
    set_timeout(25, routine_id("nag2"))
    void = graphics_mode(18)
    clear_screen()
    line = 1
    puts(1, "push any key (ESC exits)\n")
    mouse_pointer(1)
    while 1 do
	event = wait_event()
	if line >= 24 then
	    clear_screen()
	    line = 0
	end if
	mouse_pointer(0)
	if find(event, key_codes[1]) then
	    puts(1, "key = " & key_codes[2][find(event, key_codes[1])] & "\n")
	elsif find(event, event_codes[1]) then
	    puts(1, "event = " & event_codes[2][find(event, event_codes[1])] & "\n")
	elsif event > 32 and event < 256 then
	    printf(1, "key = %s\n", {event})
	elsif event < 27 then
	    printf(1, "key = Ctrl-%s\n", {'A'+event-1})
	elsif find(event, alt_lets) then
	    printf(1, "key = Alt-%s\n", {'A'+find(event, alt_lets)-1})
	elsif find(event, alt_nums) then
	    printf(1, "key = Alt-%d\n", find(event, alt_nums)-1)
	else
	    printf(1, "key code = %d\n", event)
	end if
	mouse_pointer(1)
	line += 1
	if event = 27 then
	    mouse_pointer(0)
	    puts(1, "exiting...\n\n")
	    exit
	end if
    end while
    void = graphics_mode(-1)
end procedure

main()

