-- MINNIE.EX - demo of minnie.e
-- Colin Taylor - cetaylor@compuserve.com
-- 9/9/01

include image.e
include putsxy.e
include minnie.e
include wincur_s.e

use_vesa(1)  -- you might not need this

integer text_mode, key, void, vm, mp, th, tw
sequence vc, title, modes, cursors
object m_event
title = {
    "##     ## ### ##  ### ##  ### ### ######",
    " ##   ##   #   ##  #   ##  #   #   #   #",
    " # # # #   #   # # #   # # #   #   ###  ",
    " #  #  #   #   #  ##   #  ##   #   #   #",
    "###   ### ### ###  ## ###  ## ### ######"}-32
modes = {0,1,2,3,4,5,6,7,11,13,14,15,16,17,18,19,256,257,258,259,260,261}
cursors = {ARROW_S,HELP_S,WAIT_S,BUSY_S,CROSS_S,BEAM_S,PEN_S,NO_S,SIZE1_S,
    SIZE2_S,SIZE3_S,SIZE4_S,MOVE_S,UP_S,LINK_S}
text_mode = 1
th = 8
tw = 8
vm = 4
mp = 0

procedure write(sequence pos, sequence color, sequence text)
    if not text_mode then
	pos = (pos-1)*{th, tw}
    end if
    putsxy({pos[2], pos[1]}, text, color[1], color[2], 0)
end procedure

procedure draw_box(sequence pos, sequence color, sequence size)
    write(pos, color, 218 & repeat(196, size[1]-2) & 191)
    for i = 1 to size[2]-2 do
	write(pos+{i,0}, color, 179 & repeat(32, size[1]-2) & 179)
    end for
    write(pos+{size[2]-1,0}, color, 192 & repeat(196, size[1]-2) & 217)
end procedure

procedure refresh_screen()
    sequence chars, line, m_status
    integer r, c
    chars = {191,192,193,194,196,217,218}
    cursor(NO_CURSOR)
    vc = video_config()
    -- draw_pattern
    for i = 2 to vc[VC_LINES]-1 do
	line = " "
	for j = 1 to vc[VC_COLUMNS]-2 do
	    line &= chars[rand(length(chars))]
	end for
	write({i,1}, {1,0}, line)
    end for
    -- title
    r = floor((vc[VC_LINES]-5)/2)
    c = floor((vc[VC_COLUMNS]-40)/2)
    for i = 1 to length(title) do
	for j = 1 to length(title[i]) do
	    if title[i][j] then
		write({r+i, c+j}, {0, 1}, " ")
	    else
		write({r+i, c+j}, {1, 0}, " ")
	    end if
	end for
    end for
    -- put mode info
    draw_box({2,2}, {BLACK, WHITE}, {17,6})
    if vc[VC_MODE] = modes[vm] then
	write({3,3},{BLACK, WHITE},sprintf("Video Mode %d", modes[vm]))
	if text_mode then
	    write({4,3},{BLACK, WHITE},"(text mode)")
	    write({5,3},{BLACK, WHITE},sprintf("%dx%d chars", {vc[VC_COLUMNS], vc[VC_LINES]}))
	else
	    write({4,3},{BLACK, WHITE},"(graphic mode)")
	    write({5,3},{BLACK, WHITE},sprintf("%dx%d pixels", {vc[VC_XPIXELS], vc[VC_YPIXELS]}))
	end if
	write({6,3},{BLACK, WHITE},sprintf("%d colors", vc[VC_NCOLORS]))
    else
	write({3,3},{BLACK, WHITE},"Unable to set")
	write({4,3},{BLACK, WHITE},sprintf("Mode %d", modes[vm]))
    end if
    -- put mouse info
    mouse_pointer(1)
    m_status = poll_mouse()
    draw_box({2,vc[VC_COLUMNS]-17}, {BLACK, WHITE}, {17, 6})
    write({3,vc[VC_COLUMNS]-16},{BLACK,WHITE},sprintf("mouse x = %d ", m_status[2]))
    write({4,vc[VC_COLUMNS]-16},{BLACK,WHITE},sprintf("mouse y = %d ", m_status[3]))
    write({5,vc[VC_COLUMNS]-16},{BLACK,WHITE},"buttons: L" & 250 & "M" & 250 & "R")
    -- put prompt
    draw_box({vc[VC_LINES]-6, vc[VC_COLUMNS]/2-15}, {BLACK, WHITE}, {31,6})
    write({vc[VC_LINES]-5, vc[VC_COLUMNS]/2-14}, {BLACK, WHITE}, "Spacebar changes graphic mode")
    write({vc[VC_LINES]-4, vc[VC_COLUMNS]/2-13}, {BLACK, WHITE}, "Mouse button changes cursor")
    write({vc[VC_LINES]-2, vc[VC_COLUMNS]/2-8}, {BLACK, WHITE}, "Press ESC to exit")
end procedure

procedure change_mode()
    vm += 1
    if vm > length(modes) then
	vm = 1
    end if
    void = graphics_mode(modes[vm])
    vc = video_config()
    if find(vc[VC_MODE], {0,1,2,3,7}) then
	text_mode = 1
	th = 8
    else
	text_mode = 0
	th = floor(vc[VC_YPIXELS]/vc[VC_LINES])
    end if
    mp = 1
    refresh_screen()
end procedure

procedure change_pointer()
    mp += 1
    if mp > length(cursors) then
	mp = 1
    end if
    mouse_pointer(0)
    set_mouse_cursor(cursors[mp])
    mouse_pointer(1)
end procedure

procedure update_btn()
    if and_bits(m_event[1],LEFT_DOWN) then
	write({5,vc[VC_COLUMNS]-7}, {WHITE,BLACK}, "L")
    elsif and_bits(m_event[1],LEFT_UP) then
	write({5,vc[VC_COLUMNS]-7}, {BLACK,WHITE}, "L")
    end if
    if and_bits(m_event[1],MIDDLE_DOWN) then
	write({5,vc[VC_COLUMNS]-5}, {WHITE,BLACK}, "M")
    elsif and_bits(m_event[1],MIDDLE_UP) then
	write({5,vc[VC_COLUMNS]-5}, {BLACK,WHITE}, "M")
    end if
    if and_bits(m_event[1],RIGHT_DOWN) then
	write({5,vc[VC_COLUMNS]-3}, {WHITE,BLACK}, "R")
    elsif and_bits(m_event[1],RIGHT_UP) then
	write({5,vc[VC_COLUMNS]-3}, {BLACK,WHITE}, "R")
    end if
end procedure

procedure update_pos()
    write({3,vc[VC_COLUMNS]-6},{BLACK,WHITE},sprintf("%d ", m_event[2]))
    write({4,vc[VC_COLUMNS]-6},{BLACK,WHITE},sprintf("%d ", m_event[3]))
end procedure

procedure main()
    clear_screen()
    refresh_screen()
    mouse_pointer(1)
    while 1 do
	-- check keyboard
	key = get_key()
	if key = 27 then  -- ESC
	    exit
	elsif key = ' ' then
	    change_mode()
	end if
	-- check mouse
	m_event = get_mouse()
	if sequence(m_event) then
	    if and_bits(m_event[1],LEFT_DOWN+MIDDLE_DOWN+RIGHT_DOWN) then
		-- button pressed
		change_pointer()
	    end if
	    update_btn()
	    update_pos()
	end if
    end while
    void = graphics_mode(-1)
end procedure

main()

