-- PUTSXY.E - put string at xy position
-- original version by David Alan Gay
-- Colin Taylor - cetaylor@compuserve.com
-- version 4 - 2001/8/4

include image.e

global constant CLEAR = -1
global sequence font_index
font_index = repeat(0, 256)
constant fonts = {8,8,8,14,8,8,14,14,16,16,8,16,16,16,16,16,16},
    gmodes = {4,5,6,11,13,14,15,16,17,18,19,256,257,258,259,260,261}
sequence table
integer mode, height
mode = -1

function rtrim(sequence s)  -- jiri babor
    integer i
    i = length(s)
    while i do
	if s[i] then 
	    exit 
	end if
	i -= 1
    end while
    return s[1..i]
end function

table = {}
for i = 0 to 255 do
    table &= {rtrim(reverse(int_to_bits(i, 8)))}
end for

global procedure load_font(integer fh)
-- fh = font height (8, 14 or 16)
    sequence vc, regs, char, f
    integer addr, i
    f = {{8,14},{16,8,14},{6,3,2}}
    i = find(fh, f[1])+1
    height = f[2][i]
    vc = video_config()
    mode = vc[VC_MODE]
    regs = repeat(0, 10)
    regs[REG_AX] = #1130
    regs[REG_BX] = f[3][i]*#100
    regs = dos_interrupt(#10, regs)
    addr = regs[REG_BP]+regs[REG_ES]*#10
    for j = 1 to 256 do
	char =  rtrim(peek({addr, height}))
	for k = 1 to length(char) do
	    char[k] = table[char[k]+1]
	end for
	font_index[j] =  char
	addr += height
    end for
end procedure

global procedure putsxy(sequence pos, sequence s, integer tc, integer bc, 
	integer down)
-- writes text string s to screen
    sequence vc, img, char, line
    integer attr, m, hpos, x
    vc = video_config()
    if vc[VC_MODE] != mode then
	-- reset
	m = find(vc[VC_MODE], gmodes)
	if m then
	    height = fonts[m]
	    load_font(height)
	else
	    height = 1
	end if
    end if
    if find(down, "dD") then  -- vertical text
	for i = 1 to length(s) do
	    putsxy(pos, {s[i]}, tc, bc, 0)
	    pos[2] += height
	end for
    elsif height = 1 then  -- text mode write
	attr = tc+bc*16*(bc >= 0)
	line = {}
	for i = 1 to length(s) do
	    line &= s[i] & attr
	end for
	display_text_image({pos[2], pos[1]}, {line})
    else  -- graphics mode write
	if bc = CLEAR then
	    img = save_image(pos, pos+{length(s)*8, height}-1)
	else
	    img = repeat(repeat(bc, length(s)*8), height)
	end if
	hpos = 1
	for i = 1 to length(s) do
	    char = font_index[s[i]+1]
	    for j = 1 to length(char) do
		line = char[j]
		x = hpos
		for k = 1 to length(line) do
		    if line[k] then
			img[j][x] = tc
		    end if
		    x += 1
		end for
	    end for
	    hpos += 8
	end for
	display_image(pos, img)
    end if
end procedure

