-- PUTSXY1.EX - Demo of putsxy.e
-- Colin Taylor - cetaylor@compuserve.com
-- 2001/2/12

include putsxy.e

use_vesa(1)  -- you might not need this

integer fail, mode, next_mode
sequence vc
constant hts = {1,1,1,1,8,8,8,1,14,8,8,14,14,16,16,8,16,16,16,16,16,16},
    modes = {0,1,2,3,4,5,6,7,11,13,14,15,16,17,18,19,256,257,258,259,260,261}

procedure main()
    integer x, y, key
    sequence line
    vc = video_config()
    mode = find(vc[VC_MODE], modes)
    fail = 0
    while 1 do
	clear_screen()
	puts(1, "PUTSXY DEMO 1\n")
	puts(1, repeat(196, 13) & "\n")
	next_mode = mode+1
	if next_mode > length(modes) then
	    next_mode = 1
	end if
	if fail then
	    printf(1, "Unable to select MODE %d\n", modes[mode])
	else
	    if hts[mode] = 1 then
		printf(1, "MODE %d - %dx%d Text Mode\n", {vc[VC_MODE], 
			vc[VC_LINES], vc[VC_COLUMNS]})
	    else
		printf(1, "MODE %d - %dx%d - 8x%d ROM font\n", {vc[VC_MODE], 
			vc[VC_XPIXELS], vc[VC_YPIXELS], hts[mode]})
	    end if
	end if
	printf(1, "Press SPACEBAR to change to MODE %d\n", modes[next_mode])
	position(vc[VC_LINES], 1)
	puts(1, "Press ESCAPE to quit")
	if not fail then
	    if hts[mode] = 1 then
		x = (vc[VC_COLUMNS]-32)/2+1
		y = floor((vc[VC_LINES]-10)/2)+2
	    else
		x = (vc[VC_XPIXELS]-256)/2
		y = (vc[VC_YPIXELS]-9*hts[mode])/2
	    end if
	    putsxy({x,y}, "PUTSXY character set:", 3, 0, 0)
	    y += hts[mode]
	    putsxy({x,y}, repeat(196, 21), 3, 0, 0)
	    y += hts[mode]
	    line = {}
	    for i = 0 to 31 do
		line &= i
	    end for
	    for i = 0 to 7 do
		putsxy({x,y}, line, 0, 3, 0)
		line += 32
		y += hts[mode]
	    end for
	end if
	while 1 do
	    key = get_key()
	    if key = ' ' or key = 27 then
		exit
	    end if
	end while
	if key = 27 then
	    exit
	end if
	mode = next_mode
	fail = graphics_mode(modes[mode])
	vc = video_config()
    end while
    fail = graphics_mode(-1)
end procedure

main()
