-- PUTSXT2.EX - Demo of putsxy.e
-- Colin Taylor - cetaylor@compuserve.com
-- 2001/2/12

include putsxy.e

constant char1 = {
    "   !   !",
    "      ! ",
    " !   !  ",
    "!   !   ",
    "   !   !",
    "  !     ",
    " !   !  ",
    "!   !   "}-32,
    char2 = {
    " !   !  ",
    "  !     ",
    "   !   !",
    "!   !   ",
    " !   !  ",
    "      ! ",
    "   !   !",
    "!   !   "}-32,
    char3 = {
    "  !!!!  ",
    " !!   ! ",
    " !! !   ",
    "  !!!   ",
    " !! !  !",
    " !!    !",
    "  !!!!! ",
    "        "}-32
    
procedure main()
    integer x, y, key, curr
    sequence text1, text2, text3, text4, save_char1, save_char2, 
	    back1, back2, back3, back4, colors
    atom t
    t = time()+.5
    text1 = "SPEED"
    text2 = "PIXEL PRECISION "
    text3 = "CLEAR BACKGROUND"
    text4 = "0123456789ABCDEF"
    colors = {15,7,8,CLEAR,CLEAR,8,7,15,15}
    curr = 0
    load_font(8)  -- initialize
    -- draw background
    save_char1 = font_index[129]
    font_index[129] = char1  -- redefine char 128
    save_char2 = font_index[130]
    font_index[130] = char2  -- redefine char 129
    for i = 0 to 199 by 8 do
	for j = 0 to 319 by 32 do
	    putsxy({j,i}, {128,128,129,129}, 8, 0, 0)
	end for
    end for
    -- restore chars 128 and 129
    font_index[129] = save_char1
    font_index[130] = save_char2
    -- save some backgrounds
    back1 = save_image({16,32}, {55,39})
    back2 = save_image({56,32}, {95,39})
    back3 = save_image({96,32}, {135,39})
    back4 = save_image({12,156}, {139,163})
    -- title
    putsxy({104,9}, "PUTSXY DEMO 2", 15, CLEAR, 0)
    putsxy({104,14}, repeat(196, 13), 15, CLEAR, 0)
    -- speed
    putsxy({56,32}, text1, 11, CLEAR, 0) 
    -- pixel precision
    for i = 1 to length(text2) do
	x = floor(72+65*cos(PI+i*PI/length(text3)))
	y = floor(120+72*sin(PI+i*PI/length(text3)))
	putsxy({x,y}, {text2[i]}, 12, CLEAR, 0)
    end for
    -- vertical precision
    putsxy({64,67}, "VERTICAL", 9, CLEAR, 'd')
    putsxy({80,67}, "PRINTING", 9, CLEAR, 'd')
    -- 3 fonts
    putsxy({20,140}, "3 FONTS - ", 14, CLEAR, 0)
    putsxy({100,140}, {2}, 14, CLEAR, 0)
    load_font(14)
    putsxy({112,136}, {2}, 14, CLEAR, 0)
    load_font(16)
    putsxy({124,135}, {2}, 14, CLEAR, 0)
    load_font(8)
    -- clear background
    putsxy({12,156}, text3, 15, CLEAR, 0) 
    -- redefine chars
    save_char1 = font_index['E'+1]
    font_index['E'+1] = char3
    putsxy({20,172}, "REDEFINE CHARS", 13, CLEAR, 0)
    font_index['E'+1] = save_char1
    -- font chart
    putsxy({168,39}, text4, 7, CLEAR, 0)
    putsxy({158,48}, text4, 7, CLEAR, 'd')
    for i = 0 to 15 do
	for j = 0 to 15 do
	    putsxy({168+j*8, 48+i*8},{i*16+j}, i, j, 0)
	end for
    end for
    -- prompt
    putsxy({72,192}, "<Press a key to quit>", 7, CLEAR, 0)
    -- animations
    while 1 do
	if time() > t then
	    curr += 1
	    if curr > length(colors) then
		curr = 1
	    end if
	    if remainder(curr,3) = 0 then
		-- speed animation
		t = time()+.01
		display_image({56,32}, back2)
		putsxy({16,32}, text1, 11, CLEAR, 0)
		while time() < t do
		end while
		t = time()+.01
		display_image({16,32}, back1)
		putsxy({96,32}, text1, 11, CLEAR, 0)
		while time() < t do
		end while
		display_image({96,32}, back3)
		putsxy({56,32}, text1, 11, CLEAR, 0)
	    end if
	    -- clear background animation
	    if colors[curr] = CLEAR then
		display_image({12,156}, back4)
	    else
		putsxy({12,156}, text3, colors[curr], CLEAR, 0) 
	    end if
	    t = time()+.15
	end if
	-- exit
	key = get_key()
	if key != -1 then
	    return
	end if
    end while
end procedure

if graphics_mode(19) then
    puts(1, "Unable to select mode 19\n")
else
    main()
    if graphics_mode(-1) then
    end if
end if

